unit ufrmMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, XPMan;

type
  TfrmMain = class(TForm)
    txtUsuario: TEdit;
    txtClave: TEdit;
    txtPara: TEdit;
    btnEnviar: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    XPManifest1: TXPManifest;
    chkReducir: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure btnEnviarClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

uses Registry, Jpeg, base64, uCurl;

const
  strRegKey = 'Software\jmrds.com';
  strBoundary = '{5B7BFA3E-0F1C-424A-94C3-6E3F7676473D}';

function ReadFromStream(Buffer: PAnsiChar; Size, Count: Integer;
  Stream: TStream): Integer; cdecl;
begin
  Result:= Stream.Read(Buffer^,Size*Count) div Size;
end;

// Captura la pantlla y devuelve la imagen codificada en base64
function ScreenToBase64(Reducir: Boolean): AnsiString;
var
  Bmp: TBitmap;
  Jpg: TJpegImage;
  Mem: TMemoryStream;
begin
  Bmp:= Tbitmap.Create;
  Jpg:= TJPEGImage.Create;
  Mem:= TMemoryStream.Create;
  try
    try
      Bmp.Width:= GetSystemMetrics(SM_CXSCREEN);
      Bmp.Height:= GetSystemMetrics(SM_CYSCREEN);
      BitBlt(bmp.Canvas.Handle,0,0,bmp.Width,bmp.Height,GetDc(0),0,0,SRCCOPY);
      // Reducimos la imagen a 1:2
      if Reducir then
      begin
        Bmp.Canvas.StretchDraw(Rect(0,0,Bmp.Width div 2,Bmp.Height div 2),Bmp);
        Bmp.Width:= Bmp.Width div 2;
        Bmp.Height:= Bmp.Height div 2;
      end;
      // Fin de la reducion
      jpg.Assign(bmp);
      jpg.CompressionQuality:= 60;
      jpg.Compress;
      jpg.SaveToStream(Mem);
      Result:= BinToStr(Mem.Memory,Mem.Size);
    except end;
  finally
    Mem.Free;
    Bmp.free;
    Jpg.free;
  end;
end;

// Envia el mensaje usando gmail
function EnviarStream(Usuario, Clave, Para: AnsiString; Stream: TStream): Boolean;
var
  Curl: TCURL;
  Rcpt: pcurl_slist;
begin
  Result:= FALSE;
  Curl:= curl_easy_init;
  if Curl <> nil then
  try
    if curl_easy_setopt(Curl, CURLOPT_VERBOSE, TRUE) <> CURLE_OK then
      Exit;
    if curl_easy_setopt(Curl, CURLOPT_USE_SSL, CURLUSESSL_ALL) <> CURLE_OK then
      Exit;
    {
    if curl_easy_setopt(Curl, CURLOPT_SSL_VERIFYPEER, FALSE) <> CURLE_OK then
      Exit;
    }
    if curl_easy_setopt(Curl, CURLOPT_CAINFO,'cacert.pem') <> CURLE_OK then
      Exit;
    if curl_easy_setopt(Curl, CURLOPT_SSL_VERIFYPEER, 1) <> CURLE_OK then
      Exit;
    if curl_easy_setopt(Curl, CURLOPT_USERNAME, PAnsiChar(Usuario)) <> CURLE_OK then
      Exit;
    if curl_easy_setopt(Curl, CURLOPT_PASSWORD, PAnsiChar(Clave)) <> CURLE_OK then
      Exit;
    if curl_easy_setopt(Curl, CURLOPT_URL, PChar('smtps://smtp.gmail.com')) <> CURLE_OK then
      Exit;
    if curl_easy_setopt(Curl, CURLOPT_MAIL_FROM, PAnsiChar(Usuario + '@gmail.com')) <> CURLE_OK then
      Exit;
    Rcpt:= nil;
    Rcpt:= curl_slist_append(Rcpt,PAnsiChar(Para));
    try
      if curl_easy_setopt(Curl, CURLOPT_MAIL_RCPT, Rcpt) <> CURLE_OK then
        Exit;
      if curl_easy_setopt(Curl, CURLOPT_READFUNCTION, @ReadFromStream) <> CURLE_OK then
        Exit;
      if curl_easy_setopt(Curl, CURLOPT_INFILE, Stream) <> CURLE_OK then
        Exit;
      if curl_easy_setopt(Curl, CURLOPT_UPLOAD, TRUE) <> CURLE_OK then
        Exit;
      Result:= curl_easy_perform(Curl) = CURLE_OK; 
    finally
      curl_slist_free_all(Rcpt);
    end;
  finally
    curl_easy_cleanup(Curl);
  end;
end;

procedure TfrmMain.btnEnviarClick(Sender: TObject);
var
  Usuario, Clave, Para, Texto: AnsiString;
  Stream: TMemoryStream;
begin
  // Guardamos el usuario y el destino
  with TRegistry.Create do
  try
    RootKey:= HKEY_CURRENT_USER;
    if OpenKey(strRegKey,TRUE) then
    begin
      WriteString('Usuario',txtUsuario.Text);
      WriteString('Para',txtPara.Text);
    end;
  finally
    Free;
  end;
  Usuario:= trim(txtUsuario.Text);
  Clave:= trim(txtClave.Text);
  Para:= trim(txtPara.Text);
  // Si falta algun parametro no continuamos
  if (Usuario=EmptyStr) or (Clave=EmptyStr) or (Para=EmptyStr) then
    Exit;
  // Nos ocultamos
  Hide;
  try
    Application.ProcessMessages;
    // Y esperamos un segundo
    Sleep(1000);
    // Nos aseguramos de que todo esta listo para la foto
    Application.ProcessMessages;
    // Creamos el mensaje
    Texto:= 'Captura ' + FormatDateTime('dd/mm/yyyy hh:nn:ss',Now);
    with TStringList.Create do
    try
      Add('MIME-Version: 1.0');
      Add('Subject: ' + Texto);
      Add('Content-Type: multipart/mixed; boundary=' + strBoundary);
      Add('User-Agent: Curl');
      Add(EmptyStr);
      Add('--' + strBoundary);
      Add('Content-Type: text/plain');
      Add(EmptyStr);
      Add(Texto);
      Add('--' + strBoundary);
      Add('Content-Disposition: attachment; filename=Screenshot.jpg');
      Add('Content-type: image/jpeg');
      Add('Content-Transfer-Encoding: Base64');
      Add(EmptyStr);
      // Aadimos la captura de pantalla
      Add(ScreenToBase64(chkReducir.Checked));
      Add('--' + strBoundary + '--'); 
      Stream:= TMemoryStream.Create;
      try
        SaveToStream(Stream);
        Stream.Position:= 0;
        // Enviamos el mensaje
        if EnviarStream(Usuario,Clave,Para,Stream) then
          MessageBox(Handle,PChar('Mensaje enviado: ' + Texto),PChar(Application.Title),
            MB_OK or MB_SETFOREGROUND or MB_TASKMODAL)
        else
          MessageBox(Handle,'No se ha podido completar el envio',PChar(Application.Title),
            MB_OK or MB_SETFOREGROUND or MB_TASKMODAL or MB_ICONERROR);
      finally
        Stream.Free;
      end;
    finally
      Free;
    end;
  finally
    Application.Terminate;
  end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  // Cargamos los parametros guardados durante el ultimo envio
  with TRegistry.Create do
  try
    RootKey:= HKEY_CURRENT_USER;
    if OpenKey(strRegKey,TRUE) then
    begin
      if ValueExists('Usuario') then
        txtUsuario.Text:= ReadString('Usuario');
      if ValueExists('Clave') then
        txtClave.Text:= ReadString('Clave');
      if ValueExists('Para') then
        txtPara.Text:= ReadString('Para');
    end;
  finally
    Free;
  end;
end;

end.
